<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: VTA_ProductoFinal.xml */
/* Generado: 2021-06-26 00:00:08 */

/* Busqueda de registros de la tabla VTA_ProductoFinal. */
abstract class BaseVTA_ProductoFinalFN extends VTA_ProductoFinalBN
{
    /* Declaracion de constantes */
    const ProFinalId = "VTA_ProductoFinal.ProFinalId";
    const OrdenId = "VTA_ProductoFinal.OrdenId";
    const ItemTipoClase = "VTA_ProductoFinal.ItemTipoClase";
    const Secuencia = "VTA_ProductoFinal.Secuencia";
    const IdItem = "VTA_ProductoFinal.IdItem";
    const IdOrdenPrdCab = "VTA_ProductoFinal.IdOrdenPrdCab";
    const IdLinea = "VTA_ProductoFinal.IdLinea";
    const IdFamilia = "VTA_ProductoFinal.IdFamilia";
    const IdSubFamilia = "VTA_ProductoFinal.IdSubFamilia";
    const IdAlmacen = "VTA_ProductoFinal.IdAlmacen";
    const IdUnidad = "VTA_ProductoFinal.IdUnidad";
    const IdItemTipo = "VTA_ProductoFinal.IdItemTipo";
    const DetalleDescripcion = "VTA_ProductoFinal.DetalleDescripcion";
    const Altura = "VTA_ProductoFinal.Altura";
    const Cantidad = "VTA_ProductoFinal.Cantidad";
    const CantidadRecibida = "VTA_ProductoFinal.CantidadRecibida";
    const PrecioUnitario = "VTA_ProductoFinal.PrecioUnitario";
    const ImpuestoUnitario = "VTA_ProductoFinal.ImpuestoUnitario";
    const PrecioUnitarioConIGV = "VTA_ProductoFinal.PrecioUnitarioConIGV";
    const SubTotalSinIGV = "VTA_ProductoFinal.SubTotalSinIGV";
    const ImpuestoSubTotal = "VTA_ProductoFinal.ImpuestoSubTotal";
    const PrecioTotalConIGV = "VTA_ProductoFinal.PrecioTotalConIGV";
    const DsctoTipoCod = "VTA_ProductoFinal.DsctoTipoCod";
    const DsctoCod = "VTA_ProductoFinal.DsctoCod";
    const DsctoTotal = "VTA_ProductoFinal.DsctoTotal";
    const BaseImponible = "VTA_ProductoFinal.BaseImponible";
    const ImpuestoConDscto = "VTA_ProductoFinal.ImpuestoConDscto";
    const TotalaPagar = "VTA_ProductoFinal.TotalaPagar";
    const UsuarioCreacion = "VTA_ProductoFinal.UsuarioCreacion";
    const FechaCreacion = "VTA_ProductoFinal.FechaCreacion";
    const UsuarioModificacion = "VTA_ProductoFinal.UsuarioModificacion";
    const FechaModificacion = "VTA_ProductoFinal.FechaModificacion";

    public $a_Condition = array();
    public $a_OrderBy = array();
    public $a_GroupBy = array();
    public $b_Debug = false;

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        $o_DBConnect = Conexion::getConexion();
        return $o_DBConnect;
    }

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "VTA_ProductoFinal.ProFinalId AS ProFinalId, ";
        $s_SQLQuery .= "VTA_ProductoFinal.OrdenId AS OrdenId, ";
        $s_SQLQuery .= "VTA_ProductoFinal.ItemTipoClase AS ItemTipoClase, ";
        $s_SQLQuery .= "VTA_ProductoFinal.Secuencia AS Secuencia, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdItem AS IdItem, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdOrdenPrdCab AS IdOrdenPrdCab, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdLinea AS IdLinea, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdFamilia AS IdFamilia, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdSubFamilia AS IdSubFamilia, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdAlmacen AS IdAlmacen, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdUnidad AS IdUnidad, ";
        $s_SQLQuery .= "VTA_ProductoFinal.IdItemTipo AS IdItemTipo, ";
        $s_SQLQuery .= "VTA_ProductoFinal.DetalleDescripcion AS DetalleDescripcion, ";
        $s_SQLQuery .= "VTA_ProductoFinal.Altura AS Altura, ";
        $s_SQLQuery .= "VTA_ProductoFinal.Cantidad AS Cantidad, ";
        $s_SQLQuery .= "VTA_ProductoFinal.CantidadRecibida AS CantidadRecibida, ";
        $s_SQLQuery .= "VTA_ProductoFinal.PrecioUnitario AS PrecioUnitario, ";
        $s_SQLQuery .= "VTA_ProductoFinal.ImpuestoUnitario AS ImpuestoUnitario, ";
        $s_SQLQuery .= "VTA_ProductoFinal.PrecioUnitarioConIGV AS PrecioUnitarioConIGV, ";
        $s_SQLQuery .= "VTA_ProductoFinal.SubTotalSinIGV AS SubTotalSinIGV, ";
        $s_SQLQuery .= "VTA_ProductoFinal.ImpuestoSubTotal AS ImpuestoSubTotal, ";
        $s_SQLQuery .= "VTA_ProductoFinal.PrecioTotalConIGV AS PrecioTotalConIGV, ";
        $s_SQLQuery .= "VTA_ProductoFinal.DsctoTipoCod AS DsctoTipoCod, ";
        $s_SQLQuery .= "VTA_ProductoFinal.DsctoCod AS DsctoCod, ";
        $s_SQLQuery .= "VTA_ProductoFinal.DsctoTotal AS DsctoTotal, ";
        $s_SQLQuery .= "VTA_ProductoFinal.BaseImponible AS BaseImponible, ";
        $s_SQLQuery .= "VTA_ProductoFinal.ImpuestoConDscto AS ImpuestoConDscto, ";
        $s_SQLQuery .= "VTA_ProductoFinal.TotalaPagar AS TotalaPagar, ";
        $s_SQLQuery .= "VTA_ProductoFinal.UsuarioCreacion AS UsuarioCreacion, ";
        $s_SQLQuery .= "VTA_ProductoFinal.FechaCreacion AS FechaCreacion, ";
        $s_SQLQuery .= "VTA_ProductoFinal.UsuarioModificacion AS UsuarioModificacion, ";
        $s_SQLQuery .= "VTA_ProductoFinal.FechaModificacion AS FechaModificacion ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value, $b_ComSimple = true )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value, "FLAG_COMILLAS" => $b_ComSimple );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece el orden de la lista resultante */
    public function addGroupBy( $s_Const )
    {
        $this->a_GroupBy[] = array( "COLUMN" => $s_Const );
    }

    /* Establece los valores desde un objeto VTA_ProductoFinalBN */
    public function setByBN( VTA_ProductoFinalBN $o_VTA_ProductoFinalBN )
    {
        if ( !is_null( $o_VTA_ProductoFinalBN->getProFinalId() ) )
        {
            $this->setProFinalId( $o_VTA_ProductoFinalBN->getProFinalId() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getOrdenId() ) )
        {
            $this->setOrdenId( $o_VTA_ProductoFinalBN->getOrdenId() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getItemTipoClase() ) )
        {
            $this->setItemTipoClase( $o_VTA_ProductoFinalBN->getItemTipoClase() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getSecuencia() ) )
        {
            $this->setSecuencia( $o_VTA_ProductoFinalBN->getSecuencia() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdItem() ) )
        {
            $this->setIdItem( $o_VTA_ProductoFinalBN->getIdItem() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdOrdenPrdCab() ) )
        {
            $this->setIdOrdenPrdCab( $o_VTA_ProductoFinalBN->getIdOrdenPrdCab() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdLinea() ) )
        {
            $this->setIdLinea( $o_VTA_ProductoFinalBN->getIdLinea() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdFamilia() ) )
        {
            $this->setIdFamilia( $o_VTA_ProductoFinalBN->getIdFamilia() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdSubFamilia() ) )
        {
            $this->setIdSubFamilia( $o_VTA_ProductoFinalBN->getIdSubFamilia() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_VTA_ProductoFinalBN->getIdAlmacen() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdUnidad() ) )
        {
            $this->setIdUnidad( $o_VTA_ProductoFinalBN->getIdUnidad() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getIdItemTipo() ) )
        {
            $this->setIdItemTipo( $o_VTA_ProductoFinalBN->getIdItemTipo() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getDetalleDescripcion() ) )
        {
            $this->setDetalleDescripcion( $o_VTA_ProductoFinalBN->getDetalleDescripcion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getAltura() ) )
        {
            $this->setAltura( $o_VTA_ProductoFinalBN->getAltura() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getCantidad() ) )
        {
            $this->setCantidad( $o_VTA_ProductoFinalBN->getCantidad() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getCantidadRecibida() ) )
        {
            $this->setCantidadRecibida( $o_VTA_ProductoFinalBN->getCantidadRecibida() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getPrecioUnitario() ) )
        {
            $this->setPrecioUnitario( $o_VTA_ProductoFinalBN->getPrecioUnitario() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getImpuestoUnitario() ) )
        {
            $this->setImpuestoUnitario( $o_VTA_ProductoFinalBN->getImpuestoUnitario() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getPrecioUnitarioConIGV() ) )
        {
            $this->setPrecioUnitarioConIGV( $o_VTA_ProductoFinalBN->getPrecioUnitarioConIGV() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getSubTotalSinIGV() ) )
        {
            $this->setSubTotalSinIGV( $o_VTA_ProductoFinalBN->getSubTotalSinIGV() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getImpuestoSubTotal() ) )
        {
            $this->setImpuestoSubTotal( $o_VTA_ProductoFinalBN->getImpuestoSubTotal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getPrecioTotalConIGV() ) )
        {
            $this->setPrecioTotalConIGV( $o_VTA_ProductoFinalBN->getPrecioTotalConIGV() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getDsctoTipoCod() ) )
        {
            $this->setDsctoTipoCod( $o_VTA_ProductoFinalBN->getDsctoTipoCod() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getDsctoCod() ) )
        {
            $this->setDsctoCod( $o_VTA_ProductoFinalBN->getDsctoCod() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getDsctoTotal() ) )
        {
            $this->setDsctoTotal( $o_VTA_ProductoFinalBN->getDsctoTotal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getBaseImponible() ) )
        {
            $this->setBaseImponible( $o_VTA_ProductoFinalBN->getBaseImponible() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getImpuestoConDscto() ) )
        {
            $this->setImpuestoConDscto( $o_VTA_ProductoFinalBN->getImpuestoConDscto() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getTotalaPagar() ) )
        {
            $this->setTotalaPagar( $o_VTA_ProductoFinalBN->getTotalaPagar() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_VTA_ProductoFinalBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_VTA_ProductoFinalBN->getFechaCreacion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_VTA_ProductoFinalBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_VTA_ProductoFinalBN->getFechaModificacion() );
        }
    }

    /**
    * @return VTA_ProductoFinalBN|null
    * @throws SQLException
    */
    public function selectByPK( $i_ProFinalId )
    {
        if( is_null( $i_ProFinalId ) ){ $i_ProFinalId = -1; } 
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM VTA_ProductoFinal ";
        $s_SQLQuery .= "WHERE ProFinalId = ".$i_ProFinalId." ";
        $s_SQLQuery .= "LIMIT 1;";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_VTA_ProductoFinalBN = null;
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows   = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            $o_ResultSet->next();
            $a_SQLRow = $o_ResultSet->getRow(); //devuele array
            $o_VTA_ProductoFinalBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_VTA_ProductoFinalBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getProFinalId() ) ) $s_SQLQuery .= "VTA_ProductoFinal.ProFinalId = ".$this->getProFinalId()." AND ";
        if ( !is_null( $this->getOrdenId() ) ) $s_SQLQuery .= "VTA_ProductoFinal.OrdenId = ".$this->getOrdenId()." AND ";
        if ( !is_null( $this->getItemTipoClase() ) ) $s_SQLQuery .= "VTA_ProductoFinal.ItemTipoClase = ".$this->getItemTipoClase()." AND ";
        if ( !is_null( $this->getSecuencia() ) ) $s_SQLQuery .= "VTA_ProductoFinal.Secuencia = '".$this->getSecuencia()."' AND ";
        if ( !is_null( $this->getIdItem() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdItem = '".$this->getIdItem()."' AND ";
        if ( !is_null( $this->getIdOrdenPrdCab() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdOrdenPrdCab = ".$this->getIdOrdenPrdCab()." AND ";
        if ( !is_null( $this->getIdLinea() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdLinea = ".$this->getIdLinea()." AND ";
        if ( !is_null( $this->getIdFamilia() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdFamilia = ".$this->getIdFamilia()." AND ";
        if ( !is_null( $this->getIdSubFamilia() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdSubFamilia = ".$this->getIdSubFamilia()." AND ";
        if ( !is_null( $this->getIdAlmacen() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdAlmacen = '".$this->getIdAlmacen()."' AND ";
        if ( !is_null( $this->getIdUnidad() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdUnidad = ".$this->getIdUnidad()." AND ";
        if ( !is_null( $this->getIdItemTipo() ) ) $s_SQLQuery .= "VTA_ProductoFinal.IdItemTipo = '".$this->getIdItemTipo()."' AND ";
        if ( !is_null( $this->getDetalleDescripcion() ) ) $s_SQLQuery .= "VTA_ProductoFinal.DetalleDescripcion = '".$this->getDetalleDescripcion()."' AND ";
        if ( !is_null( $this->getAltura() ) ) $s_SQLQuery .= "VTA_ProductoFinal.Altura = ".$this->getAltura()." AND ";
        if ( !is_null( $this->getCantidad() ) ) $s_SQLQuery .= "VTA_ProductoFinal.Cantidad = ".$this->getCantidad()." AND ";
        if ( !is_null( $this->getCantidadRecibida() ) ) $s_SQLQuery .= "VTA_ProductoFinal.CantidadRecibida = ".$this->getCantidadRecibida()." AND ";
        if ( !is_null( $this->getPrecioUnitario() ) ) $s_SQLQuery .= "VTA_ProductoFinal.PrecioUnitario = ".$this->getPrecioUnitario()." AND ";
        if ( !is_null( $this->getImpuestoUnitario() ) ) $s_SQLQuery .= "VTA_ProductoFinal.ImpuestoUnitario = ".$this->getImpuestoUnitario()." AND ";
        if ( !is_null( $this->getPrecioUnitarioConIGV() ) ) $s_SQLQuery .= "VTA_ProductoFinal.PrecioUnitarioConIGV = ".$this->getPrecioUnitarioConIGV()." AND ";
        if ( !is_null( $this->getSubTotalSinIGV() ) ) $s_SQLQuery .= "VTA_ProductoFinal.SubTotalSinIGV = ".$this->getSubTotalSinIGV()." AND ";
        if ( !is_null( $this->getImpuestoSubTotal() ) ) $s_SQLQuery .= "VTA_ProductoFinal.ImpuestoSubTotal = ".$this->getImpuestoSubTotal()." AND ";
        if ( !is_null( $this->getPrecioTotalConIGV() ) ) $s_SQLQuery .= "VTA_ProductoFinal.PrecioTotalConIGV = ".$this->getPrecioTotalConIGV()." AND ";
        if ( !is_null( $this->getDsctoTipoCod() ) ) $s_SQLQuery .= "VTA_ProductoFinal.DsctoTipoCod = '".$this->getDsctoTipoCod()."' AND ";
        if ( !is_null( $this->getDsctoCod() ) ) $s_SQLQuery .= "VTA_ProductoFinal.DsctoCod = '".$this->getDsctoCod()."' AND ";
        if ( !is_null( $this->getDsctoTotal() ) ) $s_SQLQuery .= "VTA_ProductoFinal.DsctoTotal = ".$this->getDsctoTotal()." AND ";
        if ( !is_null( $this->getBaseImponible() ) ) $s_SQLQuery .= "VTA_ProductoFinal.BaseImponible = ".$this->getBaseImponible()." AND ";
        if ( !is_null( $this->getImpuestoConDscto() ) ) $s_SQLQuery .= "VTA_ProductoFinal.ImpuestoConDscto = ".$this->getImpuestoConDscto()." AND ";
        if ( !is_null( $this->getTotalaPagar() ) ) $s_SQLQuery .= "VTA_ProductoFinal.TotalaPagar = ".$this->getTotalaPagar()." AND ";
        if ( !is_null( $this->getUsuarioCreacion() ) ) $s_SQLQuery .= "VTA_ProductoFinal.UsuarioCreacion = '".$this->getUsuarioCreacion()."' AND ";
        if ( !is_null( $this->getFechaCreacion() ) ) $s_SQLQuery .= "VTA_ProductoFinal.FechaCreacion = '".$this->getFechaCreacion()."' AND ";
        if ( !is_null( $this->getUsuarioModificacion() ) ) $s_SQLQuery .= "VTA_ProductoFinal.UsuarioModificacion = '".$this->getUsuarioModificacion()."' AND ";
        if ( !is_null( $this->getFechaModificacion() ) ) $s_SQLQuery .= "VTA_ProductoFinal.FechaModificacion = '".$this->getFechaModificacion()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                if( $a_Condition['FLAG_COMILLAS'] )
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM VTA_ProductoFinal WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $o_ResultSet->next();
        $i_NumRows    = $o_ResultSet->getInt( 'cnt' );
        return $i_NumRows;
    }

    /**
    * @param null $i_Position
    * @param null $i_Rows
    * @return VTA_ProductoFinalBN[]
    * @throws SQLException
    */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM VTA_ProductoFinal WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";

        if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        $a_VTA_ProductoFinalBN = array();
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            while( $o_ResultSet->next() ) 
            {
                $a_SQLRow = $o_ResultSet->getRow(); //devuele array
                $o_VTA_ProductoFinalBN = $this->insertObjectBN( $a_SQLRow );
                $a_VTA_ProductoFinalBN[] = $o_VTA_ProductoFinalBN;
            }
        }
        return $a_VTA_ProductoFinalBN;
    }

    /* Devuelve un objeto VTA_ProductoFinalBN desde un objeto propel */
    public function insertObjectBN( $a_VTA_ProductoFinal )
    {
        $o_VTA_ProductoFinalBN = new VTA_ProductoFinalBN();
        if ( !is_null( $a_VTA_ProductoFinal['ProFinalId'] ) ) $o_VTA_ProductoFinalBN->setProFinalId( ( integer ) $a_VTA_ProductoFinal['ProFinalId'] );
        if ( !is_null( $a_VTA_ProductoFinal['OrdenId'] ) ) $o_VTA_ProductoFinalBN->setOrdenId( ( integer ) $a_VTA_ProductoFinal['OrdenId'] );
        if ( !is_null( $a_VTA_ProductoFinal['ItemTipoClase'] ) ) $o_VTA_ProductoFinalBN->setItemTipoClase( ( integer ) $a_VTA_ProductoFinal['ItemTipoClase'] );
        if ( !is_null( $a_VTA_ProductoFinal['Secuencia'] ) ) $o_VTA_ProductoFinalBN->setSecuencia( $a_VTA_ProductoFinal['Secuencia'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdItem'] ) ) $o_VTA_ProductoFinalBN->setIdItem( $a_VTA_ProductoFinal['IdItem'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdOrdenPrdCab'] ) ) $o_VTA_ProductoFinalBN->setIdOrdenPrdCab( ( integer ) $a_VTA_ProductoFinal['IdOrdenPrdCab'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdLinea'] ) ) $o_VTA_ProductoFinalBN->setIdLinea( ( integer ) $a_VTA_ProductoFinal['IdLinea'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdFamilia'] ) ) $o_VTA_ProductoFinalBN->setIdFamilia( ( integer ) $a_VTA_ProductoFinal['IdFamilia'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdSubFamilia'] ) ) $o_VTA_ProductoFinalBN->setIdSubFamilia( ( integer ) $a_VTA_ProductoFinal['IdSubFamilia'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdAlmacen'] ) ) $o_VTA_ProductoFinalBN->setIdAlmacen( $a_VTA_ProductoFinal['IdAlmacen'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdUnidad'] ) ) $o_VTA_ProductoFinalBN->setIdUnidad( ( integer ) $a_VTA_ProductoFinal['IdUnidad'] );
        if ( !is_null( $a_VTA_ProductoFinal['IdItemTipo'] ) ) $o_VTA_ProductoFinalBN->setIdItemTipo( $a_VTA_ProductoFinal['IdItemTipo'] );
        if ( !is_null( $a_VTA_ProductoFinal['DetalleDescripcion'] ) ) $o_VTA_ProductoFinalBN->setDetalleDescripcion( $a_VTA_ProductoFinal['DetalleDescripcion'] );
        if ( !is_null( $a_VTA_ProductoFinal['Altura'] ) ) $o_VTA_ProductoFinalBN->setAltura( ( float ) $a_VTA_ProductoFinal['Altura'] );
        if ( !is_null( $a_VTA_ProductoFinal['Cantidad'] ) ) $o_VTA_ProductoFinalBN->setCantidad( ( float ) $a_VTA_ProductoFinal['Cantidad'] );
        if ( !is_null( $a_VTA_ProductoFinal['CantidadRecibida'] ) ) $o_VTA_ProductoFinalBN->setCantidadRecibida( ( float ) $a_VTA_ProductoFinal['CantidadRecibida'] );
        if ( !is_null( $a_VTA_ProductoFinal['PrecioUnitario'] ) ) $o_VTA_ProductoFinalBN->setPrecioUnitario( ( float ) $a_VTA_ProductoFinal['PrecioUnitario'] );
        if ( !is_null( $a_VTA_ProductoFinal['ImpuestoUnitario'] ) ) $o_VTA_ProductoFinalBN->setImpuestoUnitario( ( float ) $a_VTA_ProductoFinal['ImpuestoUnitario'] );
        if ( !is_null( $a_VTA_ProductoFinal['PrecioUnitarioConIGV'] ) ) $o_VTA_ProductoFinalBN->setPrecioUnitarioConIGV( ( float ) $a_VTA_ProductoFinal['PrecioUnitarioConIGV'] );
        if ( !is_null( $a_VTA_ProductoFinal['SubTotalSinIGV'] ) ) $o_VTA_ProductoFinalBN->setSubTotalSinIGV( ( float ) $a_VTA_ProductoFinal['SubTotalSinIGV'] );
        if ( !is_null( $a_VTA_ProductoFinal['ImpuestoSubTotal'] ) ) $o_VTA_ProductoFinalBN->setImpuestoSubTotal( ( float ) $a_VTA_ProductoFinal['ImpuestoSubTotal'] );
        if ( !is_null( $a_VTA_ProductoFinal['PrecioTotalConIGV'] ) ) $o_VTA_ProductoFinalBN->setPrecioTotalConIGV( ( float ) $a_VTA_ProductoFinal['PrecioTotalConIGV'] );
        if ( !is_null( $a_VTA_ProductoFinal['DsctoTipoCod'] ) ) $o_VTA_ProductoFinalBN->setDsctoTipoCod( $a_VTA_ProductoFinal['DsctoTipoCod'] );
        if ( !is_null( $a_VTA_ProductoFinal['DsctoCod'] ) ) $o_VTA_ProductoFinalBN->setDsctoCod( $a_VTA_ProductoFinal['DsctoCod'] );
        if ( !is_null( $a_VTA_ProductoFinal['DsctoTotal'] ) ) $o_VTA_ProductoFinalBN->setDsctoTotal( ( float ) $a_VTA_ProductoFinal['DsctoTotal'] );
        if ( !is_null( $a_VTA_ProductoFinal['BaseImponible'] ) ) $o_VTA_ProductoFinalBN->setBaseImponible( ( float ) $a_VTA_ProductoFinal['BaseImponible'] );
        if ( !is_null( $a_VTA_ProductoFinal['ImpuestoConDscto'] ) ) $o_VTA_ProductoFinalBN->setImpuestoConDscto( ( float ) $a_VTA_ProductoFinal['ImpuestoConDscto'] );
        if ( !is_null( $a_VTA_ProductoFinal['TotalaPagar'] ) ) $o_VTA_ProductoFinalBN->setTotalaPagar( ( float ) $a_VTA_ProductoFinal['TotalaPagar'] );
        if ( !is_null( $a_VTA_ProductoFinal['UsuarioCreacion'] ) ) $o_VTA_ProductoFinalBN->setUsuarioCreacion( $a_VTA_ProductoFinal['UsuarioCreacion'] );
        if ( !is_null( $a_VTA_ProductoFinal['FechaCreacion'] ) ) $o_VTA_ProductoFinalBN->setFechaCreacion( utilTimestamp::getTimestamp( $a_VTA_ProductoFinal['FechaCreacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_VTA_ProductoFinal['UsuarioModificacion'] ) ) $o_VTA_ProductoFinalBN->setUsuarioModificacion( $a_VTA_ProductoFinal['UsuarioModificacion'] );
        if ( !is_null( $a_VTA_ProductoFinal['FechaModificacion'] ) ) $o_VTA_ProductoFinalBN->setFechaModificacion( utilTimestamp::getTimestamp( $a_VTA_ProductoFinal['FechaModificacion'], "Y-m-d H:i:s" ) );
        return $o_VTA_ProductoFinalBN;
    }
}
?>